<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>

  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">

  <!-- Import Datatable sau jquery -->
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
  <div class="container">
    <h2>Task 61</h2>
    <p>Pizza 365</p>

    <form id="inputform01" class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country">Customer</label>
        </div>
        <div class="col-sm-3">
          <select id="customer-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region">Order</label>
        </div>
        <div class="col-sm-3">
          <select id="order-select" disabled name="region" class="form-control">
          </select>
        </div>
      </div>
      <h2 style="text-align: center;">Customer List</h2>
      <table class="table table-bordered table-striped table-hover" id="customer-table">
        <thead>
          <tr>
            <th>Customer ID</th>
            <th>Fullname</th>
            <th>Email</th>
            <th>Address</th>
            <th>Tel</th>
          </tr>
      </table>
    </form>

    <div class="container border border-danger">
      <div class="text-center pt-5">
        <span class="h2  border-bottom-3 pt-5" style="color: crimson; font-family: cursive;">Select Drink</span>
      </div>
      <div class="form-group">
        <label for="drink-select">Drink</label>
        <select class="form-control" id="drink-select">
          <option value="all">Please Choose!</option>
        </select>
      </div>
    </div>



  </div>
  <script>
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gCustomerSelectElement = $("#customer-select");
    var gOrderSelectElement = $("#order-select");
    const ARRAY_NAME_COL = ['customerId', 'fullname', 'email', 'address', 'phone'];
    //khai báo các cột
    const gCOL_CUSTOMERID = 0;
    const gCOL_FULLNAME = 1;
    const gCOL_EMAIL = 2;
    const gCOL_ADDRESS = 3;
    const gCOL_PHONE = 4;
    var table = $("#customer-table").DataTable({
      columns: [
        { data: ARRAY_NAME_COL[gCOL_CUSTOMERID] },
        { data: ARRAY_NAME_COL[gCOL_FULLNAME] },
        { data: ARRAY_NAME_COL[gCOL_EMAIL] },
        { data: ARRAY_NAME_COL[gCOL_ADDRESS] },
        { data: ARRAY_NAME_COL[gCOL_PHONE] },
      ]
    });
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
      onPageLoading();
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      callAPIAndLoadCustomerSelect();
      callAPIAndLoadDrinkSelect();
    }



    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //call api to get customer select
    function callAPIAndLoadCustomerSelect() {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/customers",
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToCustomerSelect(pObjRes);
          LoadCustomerTable(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToCustomerSelect(pCustomerList) {
      for (i = 0; i < pCustomerList.length; i++) {
        var bCustomerOption = $("<option/>");
        bCustomerOption.prop("value", pCustomerList[i].customerId);
        bCustomerOption.prop("text", pCustomerList[i].fullname);
        gCustomerSelectElement.append(bCustomerOption);
      };
    }



    //callback function
    gCustomerSelectElement.on("change", function () {
      gOrderSelectElement.html("");
      var bCustomerCode = $(this).val();

      console.log("Customer code is selected: " + bCustomerCode);
      getRegionsByCountryCode(bCustomerCode);
    });

    //find brandTypes array by brandId
    function getRegionsByCountryCode(pCustomerCode) {
      $.ajax({
        url: "http://localhost:8080/orders?customerID=" + pCustomerCode,
        method: "GET",
        success: function (pObjRes) {
          console.log(pObjRes);
          loadDataToRegionSelect(pObjRes);
        },
        error: function (pXhrObj) {
          console.log(pXhrObj);
        }
      });
    }

    function loadDataToRegionSelect(pOrderList) {
      if (pOrderList.length > 0) {
        gOrderSelectElement.prop("disabled", false);

        for (i = 0; i < pOrderList.length; i++) {
          var bOrderOption = $("<option/>");
          bOrderOption.prop("value", pOrderList[i].id);
          bOrderOption.prop("text", pOrderList[i].orderCode);
          gOrderSelectElement.append(bOrderOption);
        };
      } else {
        gOrderSelectElement.prop("disabled", "disabled");
      }
    }
    //call api to get drink select
    function callAPIAndLoadDrinkSelect() {
      "use strict";
      $.ajax({
        url: "http://localhost:8080/drinks",
        dataType: "json",
        type: "GET",
        success: function (paramRes) {
          console.log(paramRes)
          handleDrinkList(paramRes);
        },
        error: function (paramErr) {
          console.log(paramErr.status);
        }
      });
    }

    //hàm tạo option cho select drink
    function handleDrinkList(paramDrink) {
      "use strict";
      for (var bI = 0; bI < paramDrink.length; bI++) {
        $("#drink-select").append($("<option>", {
          text: paramDrink[bI].tenNuocUong,
          value: paramDrink[bI].maNuocUong
        }));
      }

    }

    function LoadCustomerTable(responseObject) {
      table.clear();
      //Cập nhật data cho bảng 
      table.rows.add(responseObject);
      //Cập nhật lại giao diện hiển thị bảng
      table.draw();
    }

  </script>
</body>

</html>